more tests requirements

This commit is contained in:
olszomal 2019-12-12 12:34:43 +01:00 committed by Michał Trojnara
parent 7f6ec7607f
commit 5b9f65d2f2

View File

@ -1,13 +1,34 @@
#!/bin/sh #!/bin/sh
# requires mingw64-gcc, gcab, msitools, libgsf, libgsf-devel # mingw64-gcc, gcab, msitools, libgsf, libgsf-devel
# vim-common, libfaketime packages are required
result=0 result=1
count=0
skip=0
fail=0
result_path=$(pwd) result_path=$(pwd)
cd $(dirname "$0") cd $(dirname "$0")
script_path=$(pwd) script_path=$(pwd)
result_path="${result_path}/logs" result_path="${result_path}/logs"
make_tests() {
for plik in ${script_path}/recipes/*
do
/bin/sh $plik 3>&1 2>> "results.log" 1>&2
done
count=$(grep -c "Test succeeded" "results.log")
if [ $count -ne 0 ]
then
skip=$(grep -c "Test skipped" "results.log")
fail=$(grep -c "Test failed" "results.log")
printf "%s\n" "./newtest.sh finished"
printf "%s\n" "summary: success $count, skip $skip, fail $fail"
else # no test was done
result=1
fi
}
rm -rf "${result_path}" rm -rf "${result_path}"
mkdir "${result_path}" mkdir "${result_path}"
cd "${result_path}" cd "${result_path}"
@ -15,21 +36,24 @@ cd "${result_path}"
date > "results.log" date > "results.log"
../../osslsigncode -v >> "results.log" 2>/dev/null ../../osslsigncode -v >> "results.log" 2>/dev/null
# PE and CAB files support
if [ -n "$(command -v x86_64-w64-mingw32-gcc)" ] if [ -n "$(command -v x86_64-w64-mingw32-gcc)" ]
then then
x86_64-w64-mingw32-gcc "../myapp.c" -o "test.exe" 2>> "results.log" 1>&2 x86_64-w64-mingw32-gcc "../myapp.c" -o "test.exe" 2>> "results.log" 1>&2
if [ -n "$(command -v gcab)" ]
then
gcab -c "test.ex_" "test.exe" 2>> "results.log" 1>&2
else
printf "%s\n" "gcab not found in \$PATH"
printf "%s\n" "tests for CAB files skipped, please install gcab package"
fi
else else
printf "%s\n" "x86_64-w64-mingw32-gcc not found in \$PATH" printf "%s\n" "x86_64-w64-mingw32-gcc not found in \$PATH"
printf "%s\n" "tests for PE files skipped, please install mingw64-gcc package" printf "%s\n" "tests for PE files skipped, please install mingw64-gcc package"
fi fi
if [ -n "$(command -v gcab)" ]
then # MSI files support
gcab -c "test.ex_" "test.exe" 2>> "results.log" 1>&2 if grep -q "no libgsf available" "results.log"
else
printf "%s\n" "gcab not found in \$PATH"
printf "%s\n" "tests for CAB files skipped, please install gcab package"
fi
if grep -o "no libgsf available" "results.log"
then then
printf "%s\n" "signing MSI files requires libgsf/libgsf-devel packages and reconfiguration osslsigncode" printf "%s\n" "signing MSI files requires libgsf/libgsf-devel packages and reconfiguration osslsigncode"
else else
@ -43,26 +67,28 @@ if grep -o "no libgsf available" "results.log"
printf "%s\n" "tests for MSI files skipped, please install msitools package" printf "%s\n" "tests for MSI files skipped, please install msitools package"
fi fi
fi fi
# Timestamping support
if grep -q "no libcurl available" "results.log"
then
printf "%s\n" "configure --with_curl is required for timestamping support"
fi
# Tests requirements
if [ -n "$(command -v faketime)" ] if [ -n "$(command -v faketime)" ]
then then
for plik in ${script_path}/recipes/* if [ -n "$(command -v xxd)" ]
do
/bin/sh $plik 3>&1 2>> "results.log" 1>&2
done
count=$(grep -c "Test succeeded" "results.log")
if [ $count -ne 0 ]
then then
skip=$(grep -c "Test skipped" "results.log") make_tests
fail=$(grep -c "Test failed" "results.log") result=$?
printf "%s\n" "./newtest.sh finished" rm -f "test.exe" "test.ex_" "sample.msi" "sample.wxs" "FoobarAppl10.exe"
printf "%s\n" "summary: success $count, skip $skip, fail $fail" rm -f "sign_pe.pem" "sign_msi.pem" "verify.log"
else # no test was done else
result=1 printf "%s\n" "xxd not found in \$PATH"
printf "%s\n" "tests skipped, please install vim-common package"
fi fi
rm -f "test.exe" "test.ex_" "sample.msi" "sample.wxs" "FoobarAppl10.exe"
rm -f "sign_pe.pem" "sign_msi.pem" "verify.log"
else else
printf "%s\n" "faketime not found in \$PATH" printf "%s\n" "faketime not found in \$PATH"
printf "%s\n" "tests for PE files skipped, please install faketime package" printf "%s\n" "tests skipped, please install faketime package"
fi fi
exit $result exit $result